//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  o[qgEBhÊ悤Ȑ}`
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N0502 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ;

type
  TMyPanel = class(TPanel)
  protected
    procedure Paint; override;
  public
    FBrushColor : Cardinal;
  end;

  TForm1 = class(TForm)
    Button1: TButton;
    ColorDialog1: TColorDialog;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    MyPanel : TMyPanel;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Caption := 'GDI+ o[qgEBhE';

  //TMyPanel𐶐Ĕzu
  MyPanel := TMyPanel.Create(Self);
  with MyPanel do begin
    Parent  := Self;
    Left    := 5;
    Top     := 35;
    Width   := Self.ClientWidth  - 10;
    Height  := Self.ClientHeight - Top - 5;
    Anchors := [akLeft, akTop, akRight, akBottom];
    Color   := clWhite;
    ParentBackground := False;
    DoubleBuffered   := True;

    FBrushColor := aclYellow;
  end;
end;

//=============================================================================
//  uV̐FύX
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
begin
  ColorDialog1.Color := ARGBToColorRef(MyPanel.FBrushColor);
  if ColorDialog1.Execute then begin
    MyPanel.FBrushColor := ColorRefToARGB(ColorDialog1.Color);
  end;
  MyPanel.Invalidate;
end;

{ TMyPanel }

//-----------------------------------------------------------------------------
//  TMyPanelNXPaint\bh
//  ۂ̕`R[h
//  o[qgEBhÊ悤Ȑ}`
//-----------------------------------------------------------------------------
procedure TMyPanel.Paint;
var
  LGPGraphic   : TGPGraphics;
  LGPPath      : TGPGraphicsPath;
@LGPPen       : TGPPen;
  LGPBrush     : TGPSolidBrush;
  LLeft        : Integer;
  LTop         : Integer;
  LWidth       : Integer;
  LHeight      : Integer;
  LPenWidth    : Integer;
  LSize        : Integer;
  LArrowStartX : Integer;
  LArrowStartY : Integer;
  LArrowEndX   : Integer;
  LArrowEndY   : Integer;
  LArrowHeight : Integer;
  LArrowWidth  : Integer;
  LArrowShift  : Integer;
  LPoints      : array of TGPPoint;
begin
  inherited;

  LPenWidth := 3;

  LArrowHeight := 70;
  LArrowWidth  := 30;
  LArrowShift  := 25;

  LArrowStartX := 70;
  LArrowStartY := 200;
  LArrowEndX   := LArrowStartX + LArrowShift;
  LArrowEndY   := LArrowStartY - LArrowHeight;

  //`̃TCYƈʒu̐ݒ
  LSize   := 32;
  LWidth  := 200;
  LHeight := 100;
  LLeft   := (LArrowEndX - LArrowWidth div  2) - LSize;
  LTop    := LArrowEndY - LHeight;


  //ỹIuWFNg𐶐
  LGPPen := TGPPen.Create(aclBlack, LPenWidth);
  //TGPSolidBrush𐶐
  LGPBrush := TGPSolidBrush.Create(FBrushColor);

  //TGPGraphicsIuWFNg𐶐
  LGPGraphic := TGPGraphics.Create(Canvas.Handle);

  //---------------------------------------------------------------------------
  //  pX̍쐬Jn
  //  ȉ̃R[hł͎̒lgp
  //    ̎n_ƏI_X,YWl
  //    ̕(Op`̒ӂ̐@)
  //    `̈ʒuƃTCY
  //
  //  pX̒ǉTGPGraphicsPath.AddXXX
  //---------------------------------------------------------------------------
  LGPPath := TGPGraphicsPath.Create;

  //󕔕̒`Wݒ
  SetLength(LPoints, 3);
  LPoints[1] := MakePoint(LArrowStartX, LArrowStartY);
  if (LArrowEndX = LLeft) or (LArrowEndX = LLeft + LWidth) then begin
    LPoints[0] := MakePoint(LArrowEndX, LArrowEndY + LArrowWidth div 2);
    LPoints[2] := MakePoint(LArrowEndX, LArrowEndY - LArrowWidth div 2);
  end else begin
    LPoints[0] := MakePoint(LArrowEndX + LArrowWidth div 2, LArrowEndY);
    LPoints[2] := MakePoint(LArrowEndX - LArrowWidth div 2, LArrowEndY);
  end;

  //pXɉ~ʂǉĂ(w蒼a1/4̉~)
  //
  LGPPath.AddArc(LLeft, LTop, LSize, LSize, 180, 90);
  if (LArrowEndY = LTop) then begin
    LGPPath.AddLine(LPoints[2], LPoints[1]);
    LGPPath.AddLine(LPoints[1], LPoints[0]);
  end;

  //E
  LGPPath.AddArc(LLeft + LWidth - LSize, LTop, LSize, LSize, 270, 90);
  if (LArrowEndX = LLeft + LWidth) then begin
    LGPPath.AddLine(LPoints[2], LPoints[1]);
    LGPPath.AddLine(LPoints[1], LPoints[0]);
  end;

  //E
  LGPPath.AddArc(LLeft + LWidth - LSize, LTop + LHeight - LSize, LSize, LSize, 0, 90);
  if (LArrowEndY = LTop + LHeight) then begin
    LGPPath.AddLine(LPoints[0], LPoints[1]);
    LGPPath.AddLine(LPoints[1], LPoints[2]);
  end;

  //
  LGPPath.AddArc(LLeft, LTop + LHeight - LSize, LSize, LSize, 90, 90);
  if (LArrowEndX = LLeft) then begin
    LGPPath.AddLine(LPoints[0], LPoints[1]);
    LGPPath.AddLine(LPoints[1], LPoints[2]);
  end;

  //쐬pXĕ}`ɂ
  LGPPath.CloseFigure();
  //---------------------------------------------------------------------------
  //  pX̍쐬I
  //---------------------------------------------------------------------------

  //pX̓hׂ
  //hׂKvȂΎsKv͂Ȃ(uV̐ݒsv)
  LGPGraphic.FillPath(LGPBrush, LGPPath);

  //pX̗֊s`
  //pX̕`֌W̊֐DrawXXXX
  LGPGraphic.DrawPath(LGPPen, LGPPath);


  //CreateIuWFNg͉
  LGPPen.Free;
  LGPBrush.Free;
  LGPGraphic.Free;
end;

end.
